config/routes.rb
Rails.application.routes.draw do
  resources :posts do
    resources :comments, only: [:create, :destroy]
  end

  root 'posts#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :post
  belongs_to :parent, class_name: 'Comment', optional: true

  validates :content,
    presence: true,
    length: { maximum: 3000 }

  scope :top_level, -> { where(parent_id: nil) }

  def to_anchor
    "comment-#{id}"
  end
end

app/models/post.rb
class Post < ApplicationRecord
  validates :title, presence: true
  validates :description,
    presence: true,
    length: { maximum: 9000 }

  has_many :comments, dependent: :delete_all
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
  before_action :set_post

  def create
    comment = @post.comments.create(comment_params)

    if comment.persisted?
      redirect_to post_path(@post, anchor: comment.to_anchor), notice: 'Comment added'
    else
      error_message = comment.errors.full_messages.first || 'Error happened'
      redirect_to @post, alert: error_message
    end
  end

  def destroy
    @comment = @post.comments.find(params[:id])
    @comment.destroy

    respond_to do |format|
      format.html { redirect_to post_path(@post), notice: 'Comment was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  def set_post
    @post = Post.find(params[:post_id])
  end

  def comment_params
    params.require(:comment).permit(:parent_id, :content)
  end
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
  before_action :set_post, only: [:show, :edit, :update, :destroy]

  # GET /posts
  # GET /posts.json
  def index
    @posts = Post.all.order('id DESC').page(params[:page])
  end

  # GET /posts/1
  # GET /posts/1.json
  def show
    @comments = @post.comments
    @new_comment = Comment.new
  end

  # GET /posts/new
  def new
    @post = Post.new
  end

  # GET /posts/1/edit
  def edit
  end

  # POST /posts
  # POST /posts.json
  def create
    @post = Post.new(post_params)

    respond_to do |format|
      if @post.save
        format.html { redirect_to @post, notice: 'Post was successfully created.' }
        format.json { render :show, status: :created, location: @post }
      else
        format.html { render :new }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /posts/1
  # PATCH/PUT /posts/1.json
  def update
    respond_to do |format|
      if @post.update(post_params)
        format.html { redirect_to @post, notice: 'Post was successfully updated.' }
        format.json { render :show, status: :ok, location: @post }
      else
        format.html { render :edit }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /posts/1
  # DELETE /posts/1.json
  def destroy
    @post.destroy
    respond_to do |format|
      format.html { redirect_to posts_url, notice: 'Post was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_post
    @post = Post.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def post_params
    params.require(:post).permit(:title, :description)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/helpers/welcome_helper.rb
module WelcomeHelper
end

app/views/comments/_comment.html.erb
<li id="<%= comment.to_anchor %>" class="comment-row">
  <div class="comment-content">
    <div class="comment-header">
      <span class="comment-id">
        <%= link_to comment.to_anchor, post_path(@post, anchor: comment.to_anchor) %>; <%= comment.created_at %>
      </span>

      <%= link_to 'Destroy', post_comment_path(@post, comment), method: :delete, data: { confirm: 'Are you sure?' }, class: 'float-right' %>
    </div>

    <%= simple_format comment.content %>
  </div>
</li>

app/views/comments/_form.html.erb
<%= form_for [post, @new_comment] do |form| %>
  <div class="field">
    <%= form.label :content %>
    <%= form.text_area :content, rows: 10, cols: 80 %>
    <br/>
    <small id="count"></small>
  </div>  

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/layouts/_tracking.html.erb
<%- if Rails.env.production? %>
<script>
;(function(p,l,o,w,i,n,g){if(!p[i]){p.GlobalSnowplowNamespace=p.GlobalSnowplowNamespace||[];
p.GlobalSnowplowNamespace.push(i);p[i]=function(){(p[i].q=p[i].q||[]).push(arguments)
};p[i].q=p[i].q||[];n=l.createElement(o);g=l.getElementsByTagName(o)[0];n.async=1;
n.src=w;g.parentNode.insertBefore(n,g)}}(window,document,"script","https://gitlab.dzaporozhets.me/-/sp.js","snowplow421362"));
snowplow421362("newTracker", "sp", "gitlab.dzaporozhets.me/-/collector", {
  appId: "15",
  platform: "web",
  eventMethod: "get"
});
snowplow421362('trackPageView');
</script>
<% end %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Demo</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <div class="container">
      <% if notice.present? %>
        <p id="notice"><%= notice %></p>
      <% end %>

      <% if alert.present? %>
        <p id="alert"><%= alert %></p>
      <% end %>

      <%= yield %>
    </div>

    <%= render 'layouts/tracking' %>
  </body>
</html>

app/views/posts/_form.html.erb
<%= form_with(model: post, local: true) do |form| %>
  <% if post.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(post.errors.count, "error") %> prohibited this post from being saved:</h2>

      <ul>
      <% post.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :title %>
    <%= form.text_field :title, class: 'post-title-input' %>
  </div>

  <div class="field">
    <%= form.label :description %>
    <%= form.text_area :description, rows: 20, cols: 80 %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/posts/edit.html.erb
<h1>Editing Post</h1>

<hr/>

<%= render 'form', post: @post %>

app/views/posts/index.html.erb
<h1>Posts</h1>

<%= link_to 'New Post', new_post_path %>

<hr/>

<table>
  <thead>
    <tr>
      <th>Title</th>
      <th>Description</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @posts.each do |post| %>
      <tr>
        <td><%= truncate post.title, length: 50 %></td>
        <td><%= truncate post.description, length: 50 %></td>
        <td><%= link_to 'Show', post %></td>
        <td><%= link_to 'Edit', edit_post_path(post) %></td>
        <td><%= link_to 'Destroy', post, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<%= paginate @posts %>

app/views/posts/new.html.erb
<h1>New Post</h1>

<hr/>

<%= render 'form', post: @post %>

app/views/posts/show.html.erb
<h1>Post</h1>

<hr/>

<h3><%= @post.title %></h3>

<div class="post-description">
  <%= simple_format @post.description %>
</div>

<div class="float-right">
  <%= link_to 'Edit', edit_post_path(@post) %> |
  <%= link_to 'Destroy', @post, method: :delete, data: { confirm: 'Are you sure?' } %>
</div>

<div class="post-comments">
  <h3>Comments</h3>

  <% if @comments.any? %>
    <ul class="comments-list">
      <%= render @comments %>
    </ul>
  <% end %>

  <%= render 'comments/form', post: @post %>
</div>